; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 800
WINDOWHEIGHT = 600
DM_BITSPERPEL     = 40000h
DM_PELSWIDTH      = 80000h
DM_PELSHEIGHT     = 100000h
ANTIALIASED_QUALITY = 4
WGL_FONT_POLYGONS = 1
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize	dd ?
  biWidth	dd ?
  biHeight	dd ?
  biPlanes	dw ?
  biBitCount	dw ?
  biCompression	dd ?
  biSizeImage	dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
; GMF structure- used for font handling
GLYPHMETRICSFLOAT STRUCT
  gmfBlackBoxX	dd ?
  gmfBlackBoxY	dd ?
  x		dd ?
  y		dd ?
  gmfCellIncX	dd ?
  gmfCellIncY	dd ?
GLYPHMETRICSFLOAT ENDS
GMFSIZE EQU SIZEOF GLYPHMETRICSFLOAT
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
        je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write


        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_TIMER
	je      wmTIMER
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	mov	ecx,texture
	invoke	GlobalFree
	mov	ecx,gmf
	invoke	GlobalFree
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmTIMER:movd xmm0,rot			; Increase the rotation variable
  	addss xmm0,const0_5
  	movd rot,xmm0
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
 	invoke	GlobalAlloc,sizeof GPTR,GLYPHMETRICSFLOAT*256
 	mov	gmf, eax 
        mov	ecx,offset FileName2
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_FLAG_SEQUENTIAL_SCAN,0;;FILE_ATTRIBUTE_ARCHIVE,0
        mov	esi,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	texture,eax
        mov	edi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,esi,eax,FSize,,rbx
        invoke	CloseHandle,esi
	mov	esi,edi
        add	esi,[rdi + BITMAPFILEHEADER.bfOffBits]
	lea	edi,[rdi + sizeof BITMAPFILEHEADER]
	mov	eax,[rdi + BITMAPINFOHEADER.biWidth]
        mov	w,eax
        movzx	eax, word ptr [rdi + BITMAPINFOHEADER.biHeight]
        mov	h,eax
;--------------------------------------------------------------
;	push	rsi
; BMP file has the colours as BGR instead of RGB. Swap the R & B colours.
;        mov	ecx,h
;	imul	ecx,w
;@@:	lodsb
;	xchg	al,[rsi+1]
;	mov	[rsi-1],al
;	add	esi,2
;	loop	@b
;	pop	rsi
;--------------------------------------------------------------
	mov	edx,offset Texture1_Id
	invoke	glGenTextures,1
;    
	mov	edx,Texture1_Id
	invoke	glBindTexture,GL_TEXTURE_2D; Select the texture
	mov	r8d,w
        mov	r9d,h
	invoke	gluBuild2DMipmaps,GL_TEXTURE_2D,3,,,GL_BGR,GL_UNSIGNED_BYTE,rsi
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST

        invoke	glTexGeni,GL_S, GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR; Texturing contour anchored to the object
	invoke	glTexGeni,GL_T, GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR; Texturing contour anchored to the object
	invoke	glEnable,GL_TEXTURE_GEN_S
	invoke	glEnable,GL_TEXTURE_GEN_T    
; Create the outline font
	invoke	glGenLists,256	; Create storage for 256 Characters
	mov	base,eax

	pushaddr txt_FontName
	push	FF_DONTCARE or DEFAULT_PITCH
	push	ANTIALIASED_QUALITY
	push	CLIP_DEFAULT_PRECIS
	push	OUT_TT_PRECIS
	push	SYMBOL_CHARSET
	push	rbx
	push	rbx
	push	rbx
	push	FW_BOLD
	sub	esp,20h
	mov	ecx,-12
	invoke	CreateFont,,0,0,0
	
	invoke	SelectObject,hDC,eax
        mov	eax,const0_1
	mov	[rsp+20h],rax
	mov	eax,const0_2
	mov	[rsp+28h],rax
	mov	qword ptr [rsp+30h],WGL_FONT_POLYGONS
	mov	eax,gmf
	mov	[rsp+38h],rax
	mov	r9d,base
	invoke	wglUseFontOutlinesA,hDC,0,255

	invoke	glShadeModel,GL_SMOOTH;smooth shading
	movd	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;    
	cvtss2sd xmm0,const1
	invoke	glClearDepth;   
	invoke	glEnable,GL_DEPTH_TEST ;  
	invoke	glDepthFunc,GL_LEQUAL ;  
;     ()
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
	invoke	glEnable, GL_LIGHT0              ;dirty lighting
	invoke	glEnable, GL_LIGHTING            ;enable lighting

        invoke	glEnable,GL_TEXTURE_2D;enable texture mapping (the img is 2D)
;     
	invoke	glMatrixMode,GL_PROJECTION;     ()
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT;clear screen before drawing
        invoke	glLoadIdentity
	; Position the text
	movd	xmm0,rot
	divss	xmm0,const16
	invoke	cosf
	mulss	xmm0,const1_1
	movd	w,xmm0
	
	movd	xmm0,rot
	divss	xmm0,const20
	invoke	sinf
	mulss	xmm0,const0_8
	movss	xmm1,xmm0

	movd	xmm2,const_3
	movd	xmm0,w
	invoke	glTranslatef	
; Rotate the text
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movd	xmm1,const1
	movd	xmm0,rot
	invoke	glRotatef		; Rotate on the X axis
	movd	xmm0,rot
	mulss	xmm0,const1_2

	xorps	xmm3,xmm3
	movd	xmm2,const1
	xorps	xmm1,xmm1
	invoke	glRotatef		; Rotate on the Y axis

	movd	xmm0,rot
	mulss	xmm0,const1_4

	movd	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	invoke	glRotatef		; Rotate on the Z axis
	
	movd	xmm2,const0_1
	movd	xmm1,const_0_35
	movss	xmm0,xmm1
	invoke	glTranslatef;Centre on X, Y & Z axis
; Draw the skull & crossbones symbol
	invoke	glPushAttrib, GL_LIST_BIT
	mov	ecx,base
	invoke	glListBase
	mov	r8d,offset txt_N_Skull
	invoke	glCallLists,1,GL_UNSIGNED_BYTE
	invoke	glPopAttrib
        invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #15 - Texture Mapped Outline Fonts",0
FileName	db "br_Rabbit3.cur",0
FileName2	db "lights.bmp",0
Texture1_Id	dd ?
texture		dd ?
txt_N_Skull	db "N",0
txt_FontName	db "Wingdings",0
gmf		dd ?; Define GMF array
base		dd ?; Font base
rot		dd 0; holds rotational value of text
;-----------------------------
;float
const0_1	dd 0.1
const0_2	dd 0.2
const_0_35	dd -0.35
const0_5	dd 0.5
const0_8	dd 0.8
const1		dd 1.0
const1_1	dd 1.1
const1_2	dd 1.2
const1_4	dd 1.4
const_3		dd -3.0
const16		dd 16.0
const20		dd 20.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
end